Con
  _clkmode = xtal1 + pll16x       
  _xinfreq        = 5_000_000   
  
  ird = 16        'infared detector input pin  
  pwm = 24        'pwm base output pin (for stingray wheel motors)
  spd = 80        'stingray wheel speed (up to 255 max)
   
Obj

  ir : "irtest"        'ir detector object, for sony tv compatible remotes     
  pw : "pwmx8"         'pulse width modulation object to drive stingray wheels
  
Var

  byte irc             'irc holds number for button pressed on sony tv remote, 255 = no button being pressed
  
Pub main

'initialize
  
  ir.start(ird, @irc)                         'start sony tv remote ir object on pin ird with button being pressed returned in irc
  pw.start(pwm, %00001111, 23_000)            'start pwm object on base pin @ 23khz, for stingray motor drive
    
'main loop

  repeat
                                              
    if irc == 51                              'remote menu arrow button     
      left                                    'move stingray to it's left   
      
    if irc == 52                              'remote menu arrow button     
      right                                   'move stingray to it's right       
                                                   
    if irc == 116                             'remote menu arrow button      
      forward                                 'move stingray forward     
      
    if irc == 117                             'remote menu arrow button 
      reverse                                 'move stingray backwards     

    if irc == 255                             'no button on remote being pressed
      stop                                    'stop stingray       

      
Pub stop

  move_robot(0, 0)                            'stop stingray moving
            
Pub reverse

  move_robot(-spd, -spd)                      'move stingray in reverse
                                  
Pub forward 

  move_robot(spd, spd)                        'move stingray forward
                      
Pub left

  move_robot(-spd, spd)                       'move stingray to it's left
                          
Pub right 
  
  move_robot(spd, -spd)                       'move stingray to it's right
      
                    
Pub move_robot(left_wheel, right_wheel)       'set the speed of stingrays left and right wheels,  -255=reverse to 255=forward, 0 = stop               

  left_wheel := -255 #> left_wheel <# 255                                                                                                                                               
  right_wheel := -255 #> right_wheel <# 255                                                                                                                  
  ifnot right_wheel & $80_00_00_00             
    pw.duty(pwm + 2, right_wheel & $ff)       
    pw.duty(pwm + 3, 0)                      
  else                                        
    pw.duty(pwm + 2, 0)                      
    pw.duty(pwm + 3, (0 - right_wheel) & $ff)  
  ifnot left_wheel & $80_00_00_00                      
    pw.duty(pwm + 1, left_wheel & $ff)          
    pw.duty(pwm, 0)                              
  else                                            
    pw.duty(pwm + 1, 0)                          
    pw.duty(pwm, (0 - left_wheel) & $ff)         
                                        